libstdc++: std::pmr::unsynchronized_pool_resource Class Reference

libstdc++

std::pmr::unsynchronized_pool_resource Class Reference
Utilities » Memory » Polymorphic memory resources

`#include <memory_resource>`

Inheritance diagram for std::pmr::unsynchronized_pool_resource:
[legend]

## Public Member Functions
| unsynchronized_pool_resource (const pool_options &__opts)
| unsynchronized_pool_resource (const pool_options &__opts, memory_resource *__upstream)
| unsynchronized_pool_resource (const unsynchronized_pool_resource &)=delete
| unsynchronized_pool_resource (memory_resource *__upstream)
void * | allocate (size_t __bytes, size_t __alignment=_S_max_align)
void | deallocate (void *__p, size_t __bytes, size_t __alignment=_S_max_align)
bool | is_equal (const memory_resource &__other) const noexcept
unsynchronized_pool_resource & | operator= (const unsynchronized_pool_resource &)=delete
pool_options | options () const noexcept
void | release ()
memory_resource * | upstream_resource () const noexcept

## Protected Member Functions
void * | do_allocate (size_t __bytes, size_t __alignment) override
void | do_deallocate (void *__p, size_t __bytes, size_t __alignment) override
bool | do_is_equal (const memory_resource &__other) const noexcept override

## Detailed Description

A non-thread-safe memory resource that manages pools of fixed-size blocks.

Since
  C++17

Definition at line 261 of file memory_resource.

## Constructor & Destructor Documentation

## ◆ unsynchronized_pool_resource() [1/3]

std::pmr::unsynchronized_pool_resource::unsynchronized_pool_resource | ( |  | ) |
| inline

Definition at line 268 of file memory_resource.

## ◆ unsynchronized_pool_resource() [2/3]

std::pmr::unsynchronized_pool_resource::unsynchronized_pool_resource | ( | memory_resource * | __upstream | ) |
| inlineexplicit

Definition at line 274 of file memory_resource.

## ◆ unsynchronized_pool_resource() [3/3]

std::pmr::unsynchronized_pool_resource::unsynchronized_pool_resource | ( | const pool_options & | __opts | ) |
| inlineexplicit

Definition at line 279 of file memory_resource.

## Member Function Documentation

## ◆ allocate()

void * std::pmr::memory_resource::allocate | ( | size_t | __bytes,
|  | size_t | __alignment = _S_max_align )
| inlinenodiscardinherited

Definition at line 76 of file memory_resource.h.

## ◆ deallocate()

void std::pmr::memory_resource::deallocate | ( | void * | __p,
|  | size_t | __bytes,
|  | size_t | __alignment = _S_max_align )
| inlineinherited

Definition at line 81 of file memory_resource.h.

## ◆ do_allocate()

void * std::pmr::unsynchronized_pool_resource::do_allocate | ( | size_t | __bytes,
|  | size_t | __alignment )
| overrideprotectedvirtual

Implements std::pmr::memory_resource.

## ◆ do_deallocate()

void std::pmr::unsynchronized_pool_resource::do_deallocate | ( | void * | __p,
|  | size_t | __bytes,
|  | size_t | __alignment )
| overrideprotectedvirtual

Implements std::pmr::memory_resource.

## ◆ do_is_equal()

bool std::pmr::unsynchronized_pool_resource::do_is_equal | ( | const memory_resource & | __other | ) | const
| inlineoverrideprotectedvirtualnoexcept

Implements std::pmr::memory_resource.

Definition at line 306 of file memory_resource.

## ◆ is_equal()

bool std::pmr::memory_resource::is_equal | ( | const memory_resource & | __other | ) | const
| inlinenodiscardnoexceptinherited

Definition at line 87 of file memory_resource.h.

## ◆ options()

pool_options std::pmr::unsynchronized_pool_resource::options | ( |  | ) | const
| inlinenoexcept

Definition at line 296 of file memory_resource.

## ◆ upstream_resource()

memory_resource * std::pmr::unsynchronized_pool_resource::upstream_resource | ( |  | ) | const
| inlinenoexcept

Definition at line 293 of file memory_resource.

The documentation for this class was generated from the following file:

- memory_resource